#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "Fish_FishRankRankingCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<Fish_FishRankRankingCFG> Fish_FishRankRankingCFG::msSingleton(nullptr);

int Fish_FishRankRankingCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_FishRankRankingCFGData* Fish_FishRankRankingCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, Fish_FishRankRankingCFGData>& Fish_FishRankRankingCFG::GetMapData()
{
	return mMapData;
}

void Fish_FishRankRankingCFG::Reload()
{
	mMapData.clear();
	Load();
}

void Fish_FishRankRankingCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_FishRankRankingCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mStartRank = element->IntAttribute("StartRank");
		data.mEndRank = element->IntAttribute("EndRank");
		{
			const char* RewardItme = element->Attribute("RewardItme");
			std::vector<std::string> vecRewardItme;
			boost::split(vecRewardItme, RewardItme, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecRewardItme.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecRewardItme[i].c_str(), &temp))
				{
					data.mRewardItme.push_back(temp);
				}
			}
		}
		{
			const char* RewardCount = element->Attribute("RewardCount");
			std::vector<std::string> vecRewardCount;
			boost::split(vecRewardCount, RewardCount, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecRewardCount.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecRewardCount[i].c_str(), &temp))
				{
					data.mRewardCount.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void Fish_FishRankRankingCFG::Load()
{
	Load("../Config/Fish_FishRankRankingCFG.xml");
}

Fish_FishRankRankingCFG* Fish_FishRankRankingCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_FishRankRankingCFG());
	}
	return msSingleton.get();
}
